import { TSESTree } from '@typescript-eslint/utils';
import { ParserServices } from '@typescript-eslint/parser';
import ts, { Type } from 'typescript';
export declare const typedTokenHelpers: {
    decoratorsThatCouldMeanTheDevIsValidatingAnArray: string[];
    isTypeArrayTypeOrUnionOfArrayTypes(node: TSESTree.Node, parserService: ParserServices, checker: ts.TypeChecker): boolean;
    getNodeType(node: TSESTree.Node, parserService: ParserServices, checker: ts.TypeChecker): ts.Type;
    getConstrainedTypeAtLocation(checker: ts.TypeChecker, node: ts.Node): ts.Type;
    nodeHasDecoratorsNamed(n: TSESTree.ClassDeclaration | TSESTree.PropertyDefinition | TSESTree.MethodDefinition, decoratorNames: string[]): boolean;
    getDecoratorsNamed(n: TSESTree.ClassDeclaration | TSESTree.PropertyDefinition | TSESTree.MethodDefinition, decoratorNames: string[]): TSESTree.Decorator[];
    isEnumType(type: ts.Type): boolean;
    /**
     * Checks if an import is an import of the given decorator name
     * @param imp
     * @param decoratorName
     */
    importIsDecorator(imp: TSESTree.ImportDeclaration, decoratorName: string): boolean;
    /**
     * Checks if decorator is in imports of a node
     * @param imports
     * @param decorator
     */
    decoratorIsImportedFromClassValidator(imports: TSESTree.ImportDeclaration[], decorator: TSESTree.Decorator): boolean;
    /**
     * Checks whether a decorator is a class validator decorator
     * @param program The root program node
     * @param decorator The decorator node
     */
    decoratorIsClassValidatorDecorator(program: TSESTree.Program | null, decorator: TSESTree.Decorator): boolean;
    /**
     * Gets the root program of a node
     * @param node
     */
    getRootProgram(node: TSESTree.BaseNode): TSESTree.Program | null;
    /**
     * Gets all the decorators actually imported from class-validator lib
     * @param node PropertyDefinition node
     */
    getImportedClassValidatorDecorators(node: TSESTree.PropertyDefinition): TSESTree.Decorator[];
    decoratorIsIsEnum(decorator: TSESTree.Decorator): boolean;
    areTypeFlagsSet(type: Type, flags: ts.TypeFlags[]): boolean;
};
